Unit TscDemo1;

Interface

Uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Spin;

Type
  TForm1 = Class(TForm)
    BitBtn1: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    edWidth: TEdit;
    edHeight: TEdit;
    edWeight: TEdit;
    edHiLift: TEdit;
    edTrack: TComboBox;
    edCycle: TComboBox;
    Label10: TLabel;
    edDrum: TComboBox;
    edCable: TComboBox;
    Label11: TLabel;
    Label12: TLabel;
    ListBox1: TListBox;
    edRadius: TComboBox;
    Label13: TLabel;
    edQty: TEdit;
    Label14: TLabel;
    Label15: TLabel;
    edID: TEdit;
    Label16: TLabel;
    edWD: TEdit;
    edPitch: TSpinEdit;
    Label17: TLabel;
    Label18: TLabel;
    edBQty: TEdit;
    Label19: TLabel;
    Label20: TLabel;
    edBoID: TEdit;
    Label21: TLabel;
    edBoWD: TEdit;
    edBiID: TEdit;
    edBiWD: TEdit;
    Edit1: TEdit;
    Edit2: TEdit;
    edSpaceLeft: TEdit;
    Label6: TLabel;
    Edit3: TEdit;
    Label7: TLabel;
    Procedure BitBtn1Click(Sender: TObject);
    Procedure edTrackChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  End;

Procedure SpringCalculation(Measurements: Byte;
  DoorWidth, DoorHeight, DoorWeight, DoorHiLift: Real;
  ChRad, ChLift, ChCycle, Pitch, DrumSupplier: Byte;
  Var SprQty: Integer;
  Var SprID, SprWD, SprLen, SprWeight, SprTurn: Real;
  Var BSprQty: Integer;
  Var BoSprID, BoSprWD, BoSprLen, BoSprTurn,
  BiSprID, BiSprWD, BiSprLen, BiSprTurn, BSprWeight: Real;
  Var Multiplier, Turn, aSpaceLeft: Real;
  Var ChDrum, ChCable: Byte;
  Var sCycleLife, aVersion: Real; Var aMesage: Integer); stdCall; external 'tsc.dll';

Var
  Form1             : TForm1;

Implementation

{$R *.dfm}

Const
  DataStd           : Array[1..2, 1..7] Of String[20] =
    (('D300-144', 'D400-96', 'D400-123', 'D400-144',
    'D400-156', 'D525-216', 'D800-384'),
    ('350-7', '400-8', '4125-10', '400-12',
    '5250-18', '800-32', ''));
  DataHL            : Array[1..2, 1..5] Of String[20] =
    (('D400-54HL', 'D525-54HL', 'D575-120HL', 'D800-120HL', 'D6375-164'),
    ('400-54', '5250-54', '5750-120', '6375-164', ''));
  DataFVL           : Array[1..2, 1..3] Of String[20] =
    (('D850-132VL', 'D1100-216VL', 'D1350-332VL'),
    ('850-11', '1100-18', '1350-28'));

Procedure TForm1.BitBtn1Click(Sender: TObject);
Var
  SprQty            : Integer;
  Multiplier, Turn  : Real;
  SprID, SprWD, SprLen: Real;
  SprWeight, SprTurn: Real;
  BSprQty           : Integer;
  BoSprID, BoSprWD, BoSprLen, BoSprTurn: Real;
  BiSprID, BiSprWD, BiSprLen, BiSprTurn, BSprWeight: Real;
  SpaceLeft         : Real;
  ChDrum, ChCable   : Byte;
  sCycleLife        : Real;
  sVersion          : Real;
  sMsgs             : Integer;
Begin
  ChDrum:= edDrum.ItemIndex;
  ChCable:= edCable.ItemIndex;
  SprQty:= StrToIntDef(edQty.Text, 0);
  SprID:= StrToFloatDef(edID.Text, 0);
  SprWD:= StrToFloatDef(edWD.Text, 0);
  BSprQty:= StrToIntDef(edBQty.Text, 0);
  BoSprID:= StrToFloatDef(edBoID.Text, 0);
  BoSprWD:= StrToFloatDef(edBoWD.Text, 0);
  BiSprID:= StrToFloatDef(edBiID.Text, 0);
  BiSprWD:= StrToFloatDef(edBiWD.Text, 0);

  SpringCalculation(0,
    StrToFloatDef(edWidth.Text, 0), StrToFloatDef(edHeight.Text, 0),
    StrToFloatDef(edWeight.Text, 0), StrToFloatDef(edHiLift.Text, 0),
    edRadius.ItemIndex, edTrack.ItemIndex, edCycle.ItemIndex,
    edPitch.Value, 1,
    SprQty, SprID, SprWD,
    SprLen, SprWeight, SprTurn,
    BSprQty, BoSprID, BoSprWD, BoSprLen, BoSprTurn,
    BiSprID, BiSprWD, BiSprLen, BiSprTurn, BSprWeight,
    Multiplier, Turn, SpaceLeft, ChDrum, ChCable,
    sCycleLife, sVersion, sMsgs);

  edDrum.ItemIndex:= ChDrum;
  edCable.ItemIndex:= ChCable;
  edQty.Text:= IntToStr(SprQty);
  edID.Text:= FloatToStr(SprID);
  edWD.Text:= FloatToStr(SprWD);

  edQty.Text:= IntToStr(SprQty);
  edID.Text:= FloatToStr(SprID);
  edWD.Text:= FloatToStr(SprWD);

  edBQty.Text:= IntToStr(BSprQty);
  edBoID.Text:= FloatToStr(BoSprID);
  edBoWD.Text:= FloatToStr(BoSprWD);
  edBiID.Text:= FloatToStr(BiSprID);
  edBiWD.Text:= FloatToStr(BiSprWD);

  ListBox1.Items.Clear;
//  ListBox1.Items.Add(MsgStr);
  ListBox1.Items.Add('Multiplier: ' + FormatFloat('0.0000', Multiplier) +
    ', Turns: ' + FormatFloat('0.00', Turn));
  ListBox1.Items.Add('Quantity: ' + IntToStr(SprQty) +
    ' ID: ' + FormatFloat('0.000', SprID) +
    ' WD: ' + FormatFloat('0.0000', SprWD) +
    ' Len: ' + FormatFloat('0.00', SprLen));
  ListBox1.Items.Add('Spring Weight: ' + FormatFloat('0.000', SprWeight) +
    FormatFloat(', spring is good 0.00 turns.', SprTurn));
  ListBox1.Items.Add('');
  ListBox1.Items.Add('Booster Quantity: ' + IntToStr(BSprQty));
  ListBox1.Items.Add('Outer: ' +
    ' ID: ' + FormatFloat('0.000', BoSprID) +
    ' WD: ' + FormatFloat('0.0000', BoSprWD) +
    ' Len: ' + FormatFloat('0.00', BoSprLen));
  ListBox1.Items.Add(FormatFloat('Spring is good 0.00 turns.', BoSprTurn));
  ListBox1.Items.Add('Inner: ' +
    ' ID: ' + FormatFloat('0.000', BiSprID) +
    ' WD: ' + FormatFloat('0.0000', BiSprWD) +
    ' Len: ' + FormatFloat('0.00', BiSprLen));
  ListBox1.Items.Add(FormatFloat('Spring is good 0.00 turns.', BiSprTurn));
  ListBox1.Items.Add('Booster Weight: ' + FormatFloat('0.000', BSprWeight));
//  ListBox1.Items.Add(MsgStr); //  'Booster Weight: ' + FormatFloat('0.000', BSprWeight));
  edSpaceLeft.Text:= FloatToStr(SpaceLeft);
  Edit1.Text:= IntToStr(sMsgs);
  Edit2.Text:= FloatToStr(sVersion);
  Edit3.Text:= FloatToStr(sCycleLife);
End;

Procedure TForm1.edTrackChange(Sender: TObject);
Var
  I                 : Integer;
Begin
  Case edTrack.ItemIndex Of
    0, 1, 2:
      Begin
        edDrum.Items.Clear;
        edDrum.Items.Add('');
        For I:= 1 To 7 Do
          edDrum.Items.Add(DataStd[1, I]);
      End;
    3:
      Begin
        edDrum.Items.Clear;
        edDrum.Items.Add('');
        For I:= 1 To 5 Do
          edDrum.Items.Add(DataHL[1, I]);
      End;
    4:
      Begin
        edDrum.Items.Clear;
        edDrum.Items.Add('');
        For I:= 1 To 3 Do
          edDrum.Items.Add(DataFVL[1, I]);
      End;
  End;
  edDrum.ItemIndex:= 0;
End;

End.

